#include <stdio.h>
#include <iostream.h>
#include <math.h>
#include <malloc.h>
#include <string.h>
#include "define.h"

int imm_width[1];
int imm_height[1];
double R =  56.5 ; //cm Dome Radius
double D = 280;    // cm DomeCenterDistanceToProjector

struct DistTex 
{
	float x[DefNumOfEdgesInX][DefNumOfEdgesInY];
	float y[DefNumOfEdgesInX][DefNumOfEdgesInY];
} ;

extern struct DistTex Tex;

// Look at the hard file Distortion.
correct_Textured_image(int image_width, int image_height)
{
	extern double cam_angle;
	// extern unsigned char Distortion_buffer[1024][768][3];
	// extern unsigned char Distortion_buffer_corrected[1024][768][3];
	extern int NumOfSquaresInX;
	extern int NumOfSquaresInY;
	/* FILE *file;
	if ((file = fopen ("res.txt", "w")) == NULL)
		printf ("\n pas de chance l'ami ton ffile iest emmerde...\n");  */
	
	float phi = acos (R/D);
  cout << "FOV possible du to the distance of the projector from the dome , phi = " << phi*180/3.14159 << endl;
  //cam_angle = phi*360/3.14159;
	float PhiImage = cam_angle * 3.14159 / 360.0; // phiImage is half the angle of the camera FOV (Not the Dome FOV, but the camera FOV).
	int half_image_width  = image_width  / 2;
	int half_image_height = image_height / 2;
	int W = half_image_width;
  float T = R*R/D; // See Hard Copy!!

	int ct = -1; // indice for the Tex.[ct][rt]
	int rt = -1; // indice for the Tex.[ct][rt]
	for (float PPx = 0 ; PPx<=image_width; PPx = PPx+ (image_width / (float) NumOfSquaresInX)) { // <= because 512 / 2 = 256 I want c to be = 0 then 255 then 511 (not 512!!).
		ct++; // Incrementing the colone of the Edge of the grid used for texturing the dist. Correction
		for ( float PPy=0 ; PPy<=image_height; PPy = PPy+(image_height / (float) NumOfSquaresInY)){
			if (PPy == 0) rt = 0; else rt++; // Incrementing the row of the Edge of the grid used for texturing the dist. Correction
			float Px = PPx - half_image_width;
			float Py = PPy - half_image_height;
			float P = sqrt (Px*Px + Py*Py) * T * tan(PhiImage) / W;
      float teta = atan (P / (D-T));
      float alpha = asin(D*sin(teta)/R);
      float I = tan (alpha) * W / tan(PhiImage);
      float Ix= I * Px / (sqrt (Px*Px + Py*Py));
      float Iy= I * Py / (sqrt (Px*Px + Py*Py));
      int  IIx= Ix + half_image_width;
      int  IIy= Iy + half_image_height;
			if ((IIx >= 0) && (IIx <image_width) && (IIy>=0) && (IIy < image_height)){
				Tex.x[ct][rt]   = IIx/(float)image_width;
        Tex.y[ct][rt]   = IIy/(float)image_height;
			}
			/*fprintf (file, "%f %f\n", r, p);
			if (ro == image_height/3)
				fprintf (file, "%d %d\n", co, xp);
			/*if (ro == image_height/2)
				fprintf (file, "%d %d\n", x, xp); */
		}
	}
 	//fclose (file);
}

// Look at the hard file Distortion.
correct_image(int image_width, int image_height)
{
	extern double cam_angle;
  extern unsigned char Distortion_buffer [DistWidth][DistHeight][3];
  extern unsigned char Distortion_buffer_corrected [DistWidth][DistHeight][3];
	// extern unsigned char Distortion_buffer[1024][768][3];
	// extern unsigned char Distortion_buffer_corrected[1024][768][3];
	FILE *file;
  /*	if ((file = fopen ("res.txt", "w")) == NULL)
      printf ("\n pas de chance l'ami ton ffile iest emmerde...\n"); */
	
	float phi = acos (R/D);
	float PhiImage = cam_angle * 3.14159 / 360.0; // phiImage is half the angle of the camera FOV (Not the Dome FOV, but the camera FOV).
	int half_image_width  = image_width  / 2;
	int half_image_height = image_height / 2;
	int W = half_image_width;
  float T = (R*R)/D;

	for (int PPx= 0 ; PPx<image_width; PPx++)
		for (int PPy=0 ; PPy<image_height; PPy++){
			int Px = PPx - half_image_width;
			int Py = PPy - half_image_height;
			float P = sqrt (Px*Px + Py*Py) * T * tan(PhiImage) / W;
      float teta = atan(P/(D-T));
      float alpha = asin (D*sin(teta)/R);
      float I = tan (alpha) * W / tan(PhiImage);
      int Ix = I * Px / sqrt(Px*Px+Py*Py);
      int Iy = I * Py / sqrt(Px*Px+Py*Py);
      int IIx= Ix + half_image_width;
      int IIy= Iy + half_image_height;
			if ((IIx >= 0) && (IIx <image_width) && (IIy>=0) && (IIy < image_height)){
        Distortion_buffer_corrected[PPx][PPy][0] = Distortion_buffer[IIx][IIy][0];
				Distortion_buffer_corrected[PPx][PPy][1] = Distortion_buffer[IIx][IIy][1];
				Distortion_buffer_corrected[PPx][PPy][2] = Distortion_buffer[IIx][IIy][2]; 
			}
			/*fprintf (file, "%f %f\n", r, p);
			if (ro == image_height/3)
				fprintf (file, "%d %d\n", co, xp);
			/*if (ro == image_height/2)
				fprintf (file, "%d %d\n", x, xp); */


		}
  //fclose (file);
}

